/////////////////////////////////////////////////////////////////////////////
//    kwBin - Binary editor   v0.01-BETA
//

import java.io.*;
import java.util.*;
import javax.microedition.io.Connector;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.system.*;

/*

_E[h
EURL
Ebyte buffer[] Ƀ_E[h
E\
E_~[GIFf[^t(RgɃt@C)
EgetImage(byte[] data)ŃC[W
EaddEntry(MediaImage image)ŕۑ

[h()
Ecom.nttdocomo.system.ImageStore.getInputStream()
Ebyte[]Ɋi[
EGIFf[^o
Et@C^Cv(gqHeH)

*/

// IAppli
public final class kwBin extends IApplication {
	public void start()
	{
		PhoneSystem.setAttribute(PhoneSystem.DEV_KEYPAD, 1);
		MyCanvas canvas = new MyCanvas();
		Display.setCurrent(canvas);
	}
}

final class Menu {
	int x,y;
	int pos=0;
	int items=0;
	int id[] = new int[12];
	String text[] = new String[12];

	public Menu(){
		x=4; y=6;
	}
	public Menu(int px,int py){
		x=px; y=py;
	}
	void draw(Graphics g) {
		g.clearRect(x,y,108,16*items+8);
		g.drawRect(x+2,y+2,104,16*items+4);

		g.setColor(Graphics.getColorOfRGB(0x00,0x00,0xff));
		g.fillRect(x+4,y+4+16*pos,100,16);
		g.setColor(Graphics.getColorOfRGB(0x00,0x00,0x00));

		for (int i=0;i<items;i++) {
			g.drawString(text[i],x+4,y+4+16*i + 14);
		}

	}
	void add(int i, String t) {
		id[items]=i;
		text[items]=t;
		items++;
	}
	void up() {
		pos--;
		if (pos<0) pos +=items;
	}
	void down() {
		pos++;
		if (pos>=items) pos -=items;
	}
	int get() {
		return id[pos];
	}
}

final class MyCanvas extends Canvas {
	String proxy;
	String url = null;
	String url_history[] = new String[5];
	String contentType="";
	public static Menu menu[] = new Menu[2];
	int menus = 0;
	byte buffer[] = new byte[1024*256]; // fixme!
	int size=0; // download size
	byte clipBuffer[]={};
	int mode=0;  // 0:empty 1:ok 2:progress 
	boolean selflag=false;
	boolean mode_af=false;
	boolean nibble=false;
	int selpos=0;
	int pos=0;
	int y;
	byte gif_icon[]={
		   71,  73,  70,  56,  57,  97,  32,   0,  32,   0,-128,   0,   0,   0,   0,   0,
		   -1,  -1,  -1,  33,  -7,   4,   0,   0,   0,   0,   0,  44,   0,   0,   0,   0,
		   32,   0,  32,   0,   0,   2,  72,-116,-113, -87, -53, -19,  15, -93,-100, -76,
		  -38,  -5,-128, -34,-100,  87,  13,   1,-108,  40, 102,  99,  80,  58, 105, 104,
		  -84,-116, -85,-110, -84,  36, -49,  17, -36, -32, -17, -92,  47, -67, -14,  75,
		    4,  17, -61,  67, -79, -59,  75, -46,-108,  55, -90, -19, 105,  90,  74,-101,
		   83, -88, -54,-103, -23, 104,  59,-104, -82,  -9,  11,  14,-117,  25,   5,   0,
		   59,
	};

	public MyCanvas()
	{
		proxy = IApplication.getCurrentApp().getArgs()[0];
		setSoftLabel(SOFT_KEY_1,"Exit");
		setSoftLabel(SOFT_KEY_2,"Menu");
	}

	public void load()
	{
		try {
			ImageStore i = ImageStore.selectEntry();
			if (i==null) return;
			InputStream is = i.getInputStream();
			size=0;
			pos=0;
			int c;
			while ((c=is.read()) != -1) {
				buffer[size++] = (byte)c;
			}
			is.close();

		} catch (Exception e) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("ǂݍݎs");
			dlg.show();
			return;
		}
		if (buffer[0]=='G') {
			byte buf[] = buffer;
			buffer = new byte[200*1024];
			int i=13; // header size
			if ((buf[10]&0x80)!=0) i+=(1<<((buf[10]&7)+1))*3; // g color table

			int l=size;
			int bid,bid2;
			size=0;
			while (i < l) {
				bid=buf[i]&0xff;
				bid2=buf[i+1]&0xff;
				if (bid==0x3B) break;
				if (bid==0x2C) { // image block
					if ((buf[i+9]&0x80)!=0) i+=(1<<((buf[i+9]&7)+1))*3; // l color table
					i+=10; // blocksize
					i++; // LZW size
				} else {
					i+=2;
				}
				// sub block
				if (bid==0x21 && (bid2==0xFF || bid2==0xFE)) {
					int len;
					if (bid2==0xFE) {
						contentType="text/plain";
					} else {
						if (size>0 && size<254) {
							String s = new String(buffer,0,size);
							int sep=s.indexOf(";");
							if (sep>=0) contentType = s.substring(0,sep);
							size=0;
						}
						if ((len=buf[i]&0xff)!=0) i+=len+1;
					}
					while ((len=buf[i]&0xff)!=0) {
						System.arraycopy(buf,i+1,buffer,size,len);
						size+=len;
						i+=len+1;
					}
				} else {
					while (buf[i]!=0) i+=(buf[i]&0xff)+1;
				}
				i++;
			}
		} else {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("t@Cos");
			dlg.show();
			return;
		}
	}

	public void loadImage()
	{
		try {
			ImageStore i = ImageStore.selectEntry();
			if (i==null) return;
			InputStream is = i.getInputStream();
			size=0;
			pos=0;
			int c;
			while ((c=is.read()) != -1) {
				buffer[size++] = (byte)c;
			}
			is.close();
		} catch (Exception e) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("ǂݍݎs");
			dlg.show();
			return;
		}
		if (buffer[0]=='G') contentType="image/gif";
		else if (buffer[0]==-1) contentType="image/jpeg";
	}

	public void get()
	{
		mode=2;
		repaint();
		y=0;

		String u;
		if (url.startsWith("http://")) {
			//com.nttdocomo.net.URLEncoder.encode(url);
			u = proxy + url.substring(7);
		} else {
			u = proxy + url;
		}
		String t = null;
		InputStream is = null;
		HttpConnection hc = null;
		try {
			hc = (HttpConnection)Connector.open(u,Connector.READ,true);
			hc.setRequestMethod(HttpConnection.GET);
			hc.connect();

			is = hc.openInputStream();

			size=0;
			int c;
			while ((c=is.read()) != -1) {
				buffer[size++] = (byte)c;
			}

			is.close();

			t = hc.getHeaderField("Content-Type");

			hc.close();
			mode = 0;
		} catch (Exception e) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("_E[hs");
			dlg.show();
			mode = 0;
			return;
		}
		contentType=t;
		int i;
		for (i=0;i<url_history.length-1 && url_history[i]!=null;i++)
			if (url_history[i].equals(url)) break;
		System.arraycopy(url_history,0,url_history,1,i);
		url_history[0]=url;

	}

	public void save()
	{
		byte buf[] = new byte[gif_icon.length+size+(size/0xFE)+256];
		int pos = gif_icon.length-1;
		System.arraycopy(gif_icon,0,buf,0,pos);

		// add comment (content-type;filename)
		buf[pos++] = (byte)0x21; // extention
		buf[pos++] = (byte)0xFE; // comment block
		String c = contentType+";"+"untitled.dat";
		int l=c.getBytes().length;
		buf[pos++] = (byte)l;  // block size
		System.arraycopy(c.getBytes(),0,buf,pos,l);
		pos+=l;
		buf[pos++] = (byte)0x00;  // block end

		// add application block
		buf[pos++] = (byte)0x21; // extention
		buf[pos++] = (byte)0xFF; // application block
		buf[pos++] = (byte)0x0B;
		buf[pos++] = (byte)'G';
		buf[pos++] = (byte)'I';
		buf[pos++] = (byte)'F';
		buf[pos++] = (byte)'F';
		buf[pos++] = (byte)'S';
		pos+=3;
		buf[pos++] = (byte)'0';
		buf[pos++] = (byte)'.';
		buf[pos++] = (byte)'1';

		l=0xFE;
		for(int i=0;i<size;i+=l){
			if (i+l>size) l=size-i;
			buf[pos++] = (byte)l;
			System.arraycopy(buffer,i,buf,pos,l);
			pos+=l;
		}

		buf[pos++] = (byte)0x00;  // block end
		buf[pos++] = (byte)0x3B;  // GIF END

		try {
			MediaImage m = MediaManager.getImage(buf);
			m.use();
			ImageStore.addEntry(m);
			m.unuse();
		}catch (com.nttdocomo.system.InterruptedOperationException ioe) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("s܂");
			dlg.show();
		}catch (java.io.IOException ioe) {
		}catch (com.nttdocomo.ui.UIException uie) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("ߍ݂Ɏs܂");
			dlg.show();
		}
	}

	public void saveComment()
	{
		byte buf[] = new byte[gif_icon.length+size+(size/0xFE)+256];
		int pos = gif_icon.length-1;
		System.arraycopy(gif_icon,0,buf,0,pos);

		// add comment
		buf[pos++] = (byte)0x21; // extention
		buf[pos++] = (byte)0xFE; // comment block

		int l=0xFE;
		for(int i=0;i<size;i+=l){
			if (i+l>size) l=size-i;
			buf[pos++] = (byte)l;
			System.arraycopy(buffer,i,buf,pos,l);
			pos+=l;
		}

		buf[pos++] = (byte)0x00;  // block end
		buf[pos++] = (byte)0x3B;  // GIF END

		try {
			MediaImage m = MediaManager.getImage(buf);
			m.use();
			ImageStore.addEntry(m);
			m.unuse();
		}catch (com.nttdocomo.system.InterruptedOperationException ioe) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("s܂");
			dlg.show();
		}catch (java.io.IOException ioe) {
		}catch (com.nttdocomo.ui.UIException uie) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("ߍ݂Ɏs܂");
			dlg.show();
		}
	}

	public void saveImage()
	{
		try {
			MediaImage m = MediaManager.getImage(buffer);
			m.use();
			ImageStore.addEntry(m);
			m.unuse();
		} catch (Exception e) {
			Dialog dlg = new Dialog(Dialog.DIALOG_ERROR,"Error!");
			dlg.setText("s܂");
			dlg.show();
		}
	}

	public void paint(Graphics g)
	{
		int i,j;
		g.lock();
		g.clearRect(0,0,getHeight(), getWidth());

		g.setColor(Graphics.getColorOfRGB(0x80,0x80,0x80));
		g.fillRect(0,0,getWidth(),15);
		g.fillRect(0,getHeight()-15,getWidth(),15);
		g.setColor(Graphics.getColorOfRGB(0x00,0x00,0x00));

		// 0 - 15
		for (i=0;i<16;i++) {
			g.drawString(""+i,i*14+4,14);
		}

		// status bar
		g.drawString("top:"+Integer.toHexString(y*16)
			+ " pos:" + Integer.toHexString(pos) ,2,getHeight()-2);
		if (mode_af) g.drawString("A-F",getWidth()-24,getHeight()-2);

		// print hex
		for (j=0;j*15+30<getHeight();j++) {
			for (i=0;i<16 && (y+j)*16+i<size;i++) {
				int p=(y+j)*16+i;
				if (selflag && (p >= selpos && p < pos || p >= pos && p < selpos)) {
					g.setColor(Graphics.getColorOfRGB(0x80,0x80,0xFF));
					g.fillRect(i*14+3,j*14+16,12,15);
					g.setColor(Graphics.getColorOfRGB(0,0,0));
				}
				//g.drawString(String.format("%02X",buffer[(y+j)*16+i]&0xff),
				g.drawString((Integer.toHexString(buffer[(y+j)*16+i]&0xff|0x100).toUpperCase()).substring(1),
					i*14+4,j*14+28);
			}
			if ((y+j) == pos/16) {
				g.fillRect((pos&15)*14+4,j*14+28,11,2);
			}
			if ((y+j)*16>size) break;
		}

		// draw menu
		for (i=0;i<menus;i++) {
			menu[i].draw(g);
		}

		g.unlock(true);
	}

	public void processIMEEvent(int type,String text)
	{
		if (type==IME_CANCELED) return;

		if (mode==3) {
			mode = 0;
			contentType = text;
			return;
		}

		url = text;

		if (url.length()<1) return;

		Dialog dlg = new Dialog(Dialog.DIALOG_YESNO,"OK?");
		dlg.setText("Download ܂?");
		if (dlg.show() == Dialog.BUTTON_YES ) {
			// download!
			get();
		}

		repaint();
	}

	public void processEvent(int type,int param)
	{
		if(type == Display.KEY_PRESSED_EVENT){

			// change mode
			if(param == Display.KEY_SOFT1) {
				IApplication.getCurrentApp().terminate();
				return;
			}
			if(param == Display.KEY_SOFT2) {
				if (menus>0) {
					// Close
					menus--;
					menu[menus] = null;
				} else {
					// Menu
					menu[menus] = new Menu();
					menu[menus].add(1,"J");
					menu[menus].add(2,"摜J");
					menu[menus].add(13,"VK쐬");
					menu[menus].add(10,"ҏW");
					//menu[menus].add(31,"URLJ");
					menu[menus].add(3,"ۑ");
					if (contentType!=null) {
						if (contentType.startsWith("image/"))
							menu[menus].add(4,"摜ۑ");
						if (contentType.startsWith("text/"))
							menu[menus].add(5,"Rg̈ۑ");
					}
					menu[menus].add(12,"^Cvݒ");
					//menu[menus].add(11,"");
					menu[menus].add(99,"About kwBin");
					menu[menus].add(-1,"I");
					menus++;
				}
			}

			if (menus>0) {
				if (param == Display.KEY_CLEAR) {
					// Close
					menus--;
					menu[menus] = null;
				}
				if (param == Display.KEY_UP) {
					menu[menus-1].up();
				} else if (param == Display.KEY_DOWN) {
					menu[menus-1].down();
				} else if (param == Display.KEY_SELECT) {
					int id = menu[menus-1].get();
					if (id==10) {
						// Edit
						menu[menus] = new Menu(40,50);
						menu[menus].add(101,"؂");
						menu[menus].add(102,"Rs[");
						menu[menus].add(103,"\t");
						menus++;
					} else if (id==11) {
						menu[menus] = new Menu(40,50);
						for(int i=0;i<url_history.length && url_history[i]!=null;i++)
							menu[menus].add(110+i,url_history[i].substring(7,24));
						menu[menus].add(119,"NA");
						menus++;
					} else {
						menus--;
						menu[menus] = null;
					}

					if (id==1) {
						load();
					}else if (id==2) {
						loadImage();
					}
					if (id==13) {
						pos=0;
						size=0;
					}
					if (id==31) {
						imeOn(url,TextBox.DISPLAY_ANY,
							TextBox.ALPHA);
					}
					if (id==12) {
						mode = 3; // change type
						imeOn(url,TextBox.DISPLAY_ANY,
							TextBox.ALPHA);
					}
					if (id==32) {
						get();
					}
					if (id==3) {
						save();
					}
					if (id==4) {
						saveImage();
					}
					if (id==5) {
						saveComment();
					}
					if (id==99) {
						Dialog dlg = new Dialog(Dialog.DIALOG_INFO,"kwFetch");
						dlg.setText("kwBin Ver. 0.01\nCopyright(C) rl\n\nproxy:\n"+proxy
							+ "\nfile-type: "+contentType
							+ "\nfile-size: "+size);
						dlg.show();
					}
					if (id==101 || id==102) { // cut or copy
						int p,l;
						if (pos>selpos) {
							p=selpos;
							l=pos-selpos;
						} else {
							p=pos;
							l=selpos-pos;
						}
						if (l>0) {
							clipBuffer = new byte[l];
							System.arraycopy(buffer,p,clipBuffer,0,l);
						}
						if (id==101) { // cut
							System.arraycopy(buffer,p,buffer,p+l,size-p-l);
							size-=l;
						}
					}
					if (id==103) { // paste
						System.arraycopy(clipBuffer,0,buffer,pos,clipBuffer.length);
						pos+=clipBuffer.length;
						if (pos>size) size=pos;
					}
					if (id==-1) {
						IApplication.getCurrentApp().terminate();
					}
				}
			} else { // menus==0
				if (param == Display.KEY_SELECT) {
					selflag = !selflag;
					if (selflag)
						selpos = pos;
				} else if (param == Display.KEY_UP) {
					if (pos>=16) {
						pos-=16;
					}
				} else if (param == Display.KEY_DOWN) {
					if (pos<=size-16) {
						pos+=16;
					}
				} else if (param == Display.KEY_LEFT) {
					if (pos>0) pos--;
				} else if (param == Display.KEY_RIGHT) {
					if (pos<size) pos++;
				}
				if (param>=Display.KEY_0 && param<=Display.KEY_9) {
					int p=param;
					if (mode_af) p+=9;
					if (pos>=size) size=pos+1;
					if (nibble) {
						buffer[pos]|=p;
						pos++;
					} else {
						buffer[pos]=(byte)(p<<4);
					}
					nibble=!nibble;
				}
				if (param==Display.KEY_POUND) {
					mode_af=!mode_af;
				}
				if (param == Display.KEY_CLEAR) {
					if (pos>0) {
						pos--;
						size--;
						for(int i=pos;i<size;i++)
							buffer[i]=buffer[i+1];
					}
				}

				if (y>pos/16) y=pos/16;
				if (y+12<pos/16) y=pos/16-13;
				if (y<0) y=0;
			}

			if (menus==0) {
				setSoftLabel(SOFT_KEY_2,"Menu");
			} else {
				setSoftLabel(SOFT_KEY_2,"");
			}
			repaint();

		}
	}
}
