//    kwCalc  v0.01-BETA
//
//// const:
//   0x10 - 0x14
//    +,-,*,/,^

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

// IAppli
public final class kwCalc extends IApplication {
	public void start()
	{
		PhoneSystem.setAttribute(PhoneSystem.DEV_KEYPAD, 1);
		MyCanvas canvas = new MyCanvas();
		Display.setCurrent(canvas);
	}
}

// Real for DoJa?
final class MyReal{
	long value = 0;
	int exp = 0;

	// Constructor
	public MyReal(){}
	public MyReal(MyReal a){set(a);}
	public MyReal(String a){set(a);}
	public MyReal(long   a){set(a);}

	public long getInt()
	{
		long v = value;
		int e = exp;
		while(e>0) {
			e--;
			v*= 10;
		}
		while(e<0) {
			e++;
			v/= 10;
		}
		return v;
	}

	void set(String a)
	{
		a.trim();
		int p,e;
		exp = 0;

		p = a.indexOf('E');
		if (p>=0) {
			exp+=Integer.parseInt(a.substring(p+1));
			a = a.substring(0,p);
		}

		p = a.indexOf('.');
		if (p>=0) {
			exp-= (a.length()-p-1);
			a = a.substring(0,p)+a.substring(p+1);
			if (a.indexOf('.')>=0) return; // ERROR!
		}

		if (a.length()>18 ) {
			exp+=a.length()-18;
			a = a.substring(0,18);
		}
		value = Long.parseLong(a);
	}

	public void set(MyReal a)
	{
		value = a.value;
		exp = a.exp;
	}

	public void set(long a)
	{
		value = a;
		exp = 0;
	}

	public void inv() {
		value=-value;
	}

	public int sgn() {
		return value>0?1:value<0?-1:0;
	}
	public void abs() {
		if (value<0) value=-value;
	}

	public boolean isBig(MyReal a) {
		MyReal b = new MyReal(this);
		b.sub(a);
		return b.value>0;
	}

	public boolean isNear(MyReal a) {
		reg();
		a.reg();
		return exp==a.exp && ((value>a.value)?(value-a.value):(a.value-value)) < 100;
	}

	// Get digit
	int getDigit()
	{
		long v=value;
		int d=0;
		while(v!=0) {
			v/=10;
			d++;
		}
		return d;
	}

	// reg value
	void reg()
	{
		if (value==0) {
			exp = 0;
			return;
		}
		int d=getDigit();
		while (d<18) {
			exp--;
			value*=10;
			d++;
		}
		while (d>18 ) {
			exp++;
			value=(value+5)/10;
			d--;
		}
	}

	public void add(MyReal a)
	{
		reg();
		a.reg();
		int d=getDigit();
		int a_d=a.getDigit();
		int a_exp=a.exp;
		long a_value=a.value;

		while(exp!=a_exp) {
			if(exp>a_exp){
				if (d>=17 || a_value%10==0) {
					a_value=(a_value+5)/10;
					a_exp++;
					a_d--;
				} else {
					value*=10;
					exp--;
					d++;
				}
			} else {
				if (a_d>=17 || value%10==0) {
					value=(value+5)/10;
					exp++;
					d--;
				} else {
					a_value*=10;
					a_exp--;
					a_d++;
				}
			}
		}
		value+=a_value;
	}

	public void sub(MyReal a)
	{
		MyReal b = new MyReal(a);
		b.value = -b.value;
		add(b);
	}

	public void mul(MyReal a)
	{
		int d=getDigit();
		int a_d=a.getDigit();
		int a_exp=a.exp;
		long a_value=a.value;

		MyReal b=new MyReal(this);
		b.reg();
		a.reg();

		long a_1,a_2,b_1,b_2;
		a_1 = a.value/1000000000;
		b_1 = b.value/1000000000;
		a_2 = a.value-1000000000*a_1;
		b_2 = b.value-1000000000*b_1;

		exp=a.exp+b.exp;
		value = a_1 * b_1;
		value+= a_1 * b_2 /1000000000;
		value+= a_2 * b_1 /1000000000;

		long tmp;
		tmp = a_2 * b_2;
		tmp+= (a_1 * b_2 %1000000000) * 1000000000;
		tmp+= (a_2 * b_1 %1000000000) * 1000000000;

		d = getDigit();
		while (d>0) {
			tmp/=10;
			tmp+=(value%10)*100000000000000000L;
			value/=10;
			exp++;
			d--;
		}
		value=tmp;
	}

	public void div(MyReal a)
	{
		reg();
		a.reg();
		int d=getDigit();
		int a_d=a.getDigit();
		int a_exp=a.exp;
		long a_value=a.value;

		MyReal b=new MyReal(this);
		if (a.isBig(this)) {
			a_value=(a_value+5)/10;
			a_exp++;
		}
		value=0;
		long tmp;
		while (b.value!=0) {
			tmp = b.value/a_value;
			b.value-= tmp*a_value;
			value+=tmp;
			b.value*=10;

			if (getDigit()>17) break;

			value*=10;
			exp--;
		}
		exp-=a_exp;
	}

	public void mod(MyReal a)
	{
		MyReal d = new MyReal(this);
		d.div(a);
		d.set(d.getInt());
		d.mul(a);
		sub(d);
	}

	// Real to String
	public String str()
	{
		// reg
		while (exp>0 && value<1000000000000000L) {
			exp--;
			value*=10;
		}
		while (exp<0 && (value>=1000000000000000L || value%10==0)) {
			exp++;
			value=(value)/10;
		}
		String s="";
		long v=value;
		if (v<0) v=-v;

		int e=exp;
		int e2=0;

		while(v!=0 || e<=e2) {
			if (( e<-7 || exp>0) && v<10) {
				e2=e;
			}
			if (e==e2) {
				s="."+s;
			}
			s=v%10+s;
			v/=10;
			e++;
		}

		if (e2!=0) {
			s+=" x10^"+e2;
		}

		if (value<0) {
			s="-"+s;
		}

		long n=value&((1<<exp)-1);
		return s;
	}

}


final class MyMath {
	public static MyReal PI = new MyReal("3.14159265358979323");
	public static MyReal E  = new MyReal("2.71828182845904526");

	public static MyReal sqrt(MyReal x) {
		MyReal a = new MyReal(x);
		MyReal c2 = new MyReal(2);
		MyReal d = new MyReal();
		a.div(c2);

		if (x.sgn()<0) {
			a.set(-8888);
			return a;
		}

		do {
			//a=(a+x/a) / 2;
			d.set(x);
			d.div(a);
			a.add(d);
			a.div(c2);

			// d:= a^2
			d.set(a);
			d.mul(a);
		} while (!d.isNear(x));
		return a;
	}

	public static MyReal pow(MyReal x,MyReal y) {
		MyReal a = new MyReal(1);
		MyReal b = new MyReal(y);
		MyReal z = new MyReal(0);
		MyReal xn = new MyReal(x);
		boolean invf=false;
		if (b.sgn()<0) {
			b.inv();
			invf=true;
		}
		long v=b.getInt();

		while(v!=0){
			if((v&1)!=0){
				a.mul(xn);
			}
			xn.mul(xn);
			v>>=1;
		}

		MyReal c1 = new MyReal(1);
		b.mod(c1);

		xn.set(x);
		v=0;
		while(!b.isNear(z) && v++<60){
			xn.set(sqrt(xn));
			b.add(b); // b*= 2
			if (b.getInt()!=0) {
				b.sub(c1);
				a.mul(xn);
			}
		}

		if (invf) {
			b.set(1);
			b.div(a);
			return b;
		}
		return a;
	}

	public static MyReal exp(MyReal x) {
		MyReal a = new MyReal();
		MyReal xn = new MyReal(1);
		MyReal d = new MyReal();

		MyReal b = new MyReal();
		long di=1;
		int i;
		for (i=1;i<30;i++) {
			d.set(di);
			b.set(xn);
			b.div(d);
			a.add(b);

			di*=i;
			xn.mul(x);
		}
		return a;
	}

	public static MyReal sin(MyReal x) {
		MyReal a = new MyReal(x);

		MyReal c2 = new MyReal(2);
		MyReal hpi = new MyReal(PI);
		hpi.div(c2);

		a.sub(hpi);
		return cos(a);
	}

	public static MyReal cos(MyReal x) {
		// x2 = |x| mod 2*PI
		MyReal x2 = new MyReal(x);
		MyReal tmp = new MyReal(2);
		tmp.mul(PI);  // tmp = 2*PI
		x2.abs();
		x2.mod(tmp);

		if (x2.isBig(PI)) {
			x2.inv();
			x2.add(tmp);
		}

		MyReal a = new MyReal();
		MyReal d = new MyReal(1);
		int i;
		for (i=1;i<40;i+=2) {
			a.add(d);

			d.inv();
			d.mul(x2);
			d.mul(x2);

			tmp.set(i);
			d.div(tmp);
			tmp.set(i+1);
			d.div(tmp);

		}

		return a;
	}

	public static MyReal tan(MyReal x) {
		MyReal a = sin(x);
		a.div(cos(x));
		return a;
	}

	public static MyReal asin(MyReal x) {
		MyReal xn = new MyReal(1);
		MyReal x2 = new MyReal(x);
		x2.mul(x);
		xn.sub(x2);
		x2.set(x);
		x2.div(sqrt(xn));
		return atan(x2);
	}

	public static MyReal acos(MyReal x) {
		MyReal xn = new MyReal(1);
		MyReal x2 = new MyReal(x);
		x2.mul(x);
		xn.sub(x2);
		x2.set(sqrt(xn));
		x2.div(x);
		return atan(x2);
	}

	public static MyReal atan(MyReal x) {
		MyReal a = new MyReal();
		MyReal d = new MyReal(1);
		MyReal tmp = new MyReal();

		// x2 = |x|
		MyReal x2 = new MyReal(x);
		int size=0;
		boolean invf=false;
		if (x2.sgn()<0) {
			invf=true;
			x2.inv();
		}

		a.set("0.5");
		if (x2.isBig(a)){
			size++;
			// x2 := (x2-1)/(x2+1)
			tmp.set(x2);
			tmp.add(d);
			x2.sub(d);
			x2.div(tmp);
		}

		if (x2.isBig(a)){
			size++;

			// tmp = sqrt(2) - 1
			tmp.set(2);
			tmp.set(MyMath.sqrt(tmp));
			tmp.sub(d);

			a.set(x2);
			// x2 = (x2 - tmp)
			x2.sub(tmp);

			// tmp = x2*tmp + 1
			tmp.mul(a);
			tmp.add(d);

			// x2 / tmp
			x2.div(tmp);
		}

		a.set(0);
		MyReal xn = new MyReal(x2);
		for (int i=1;i<50;i+=2) {
			if ((i&2)==0) d.set(i);
				else  d.set(-i);
			tmp.set(xn);
			tmp.div(d);
			a.add(tmp);

			xn.mul(x2);
			xn.mul(x2);
		}

		if (size>1) {
			// + PI/8
			d.set(8);
			tmp.set(PI);
			tmp.div(d);
			a.add(tmp);
		}
		if (size>0) {
			// + PI/4
			d.set(4);
			tmp.set(PI);
			tmp.div(d);
			a.add(tmp);
		}

		if (invf) a.inv();
		return a;
	}

	public static MyReal log(MyReal x) {
		MyReal a=new MyReal();
		MyReal d=new MyReal();
		MyReal x2=new MyReal(x);
		MyReal tmp=new MyReal(1);
		MyReal ln2=new MyReal("0.693147180559945309");
		int e=0;
		tmp.set(2);
		while(x2.isBig(tmp)) {
			x2.div(tmp);
			e++;
		}


		// x2 = (x-1)(x+1)
		d.set(x2);
		tmp.set(1);
		x2.sub(tmp);
		d.add(tmp);
		x2.div(d);

		MyReal xn=new MyReal(x2);
		for (int i=1;i<100;i+=2) {
			tmp.set(xn);
			d.set(i);
			tmp.div(d);
			a.add(tmp);
			xn.mul(x2);
			xn.mul(x2);
		}

		// a = 2*a
		a.add(a);

		tmp.set(e);
		ln2.mul(tmp);
		a.add(ln2);
		return a;
	}

	public static MyReal fact(MyReal x) {
		long k = x.getInt();
		MyReal a=new MyReal(1);
		MyReal b=new MyReal();
		if (k<0 || k>100000) {
			return a;
		}
		for (int i=2;i<=k;i++) {
			b.set(i);
			a.mul(b);
		}
		return a;
	}

}

final class Calc { // can't forget to call Calc.clear();
	public static int data[] = new int[256];
	public static int cur;
	public static boolean editFlag;
	public static MyReal var[] = new MyReal[7];

	public static void clear(){
		editFlag = true;
		cur = 0;
		data[0] = -1;  // end mark
	}

	public static void del(){
		editFlag = true;
		int i;
		if (cur>0) {
			cur--;
			for(i=cur;data[i]>=0;i++){
				data[i]=data[i+1];
			}
		}
	}

	public static void add(int dat){
		if (!editFlag) {
			editFlag = true;
			if (dat>0x10 && dat<0x100) {
				cur = 1;
				data[0] = 0x109; // Ans
				data[1] = -1;
			} else {
				cur = 0;
				data[0] = -1;
			}
		}
		int i,tmp;
		for (i=cur;i<256;i++) {
			tmp=data[i];
			data[i]=dat;
			dat=tmp;
			if (data[i]<0) break;
		}
		data[i+1]=dat;
		cur++;
	}

	public static int calc(MyReal ans) {
		editFlag = false;
		if (data[0]<0) {
			ans.set(0);
			return 0;
		}

		// calculation stack
		MyReal numStack[] = new MyReal[32];
		int numPos=0;
		int expStack[] = new int[32];
		int expPos=0;

		expStack[expPos] = '(';
		String num = "";

		int i,state=0,d;
		for (i=0;i<numStack.length;i++)
			numStack[i] = new MyReal();
		for (i=0;i<255;i++) {
			d=data[i];
			if (d<0) d = ')';  // term
			if (d=='-' && (i==0 ||  data[i-1]>0x10 && data[i-1]!=')')) {
				num = "-";
			} else if (d<16) {
				if (d>=0 && d<=9)
					num+=""+d;
				if (d==10)
					num+=".";
			} else if ((d&0xf0)==0x90) {
				if (d>=0x90 && d<=0x96) {
					numStack[numPos].set(var[d&0xf]);
				} else switch (d) {
					case 0x97:
						numStack[numPos].set(MyMath.PI);
						break;
					case 0x98:
						numStack[numPos].set(MyMath.E);
						break;
					case 0x9a:
						numStack[numPos].set(ans);
						break;
					default:
				}
				if (num=="-") numStack[numPos].inv();
				numPos++;
				num="";
			} else {
				if (num == "-") {
					expStack[++expPos] = 0x8f; // -
					num = "";
				} else if (num != "") {
					numStack[numPos].set(num);
					numPos++;
					num = "";
				}

				int pri = getPriority(d);
				if (pri==6) {
					expStack[++expPos] = d;
					continue;
				}

				if (expStack[expPos]>=0x10 && expStack[expPos]<0x20) {
					numPos--;
				}
				if (numPos<1) return 2;
				if (d != '(') while(expPos>=0 && getPriority(expStack[expPos]) >= pri ){
					switch (expStack[expPos]) {
						case 0x10: // +
							numStack[numPos-1].add(numStack[numPos]);
							break;
						case 0x11: // -
							numStack[numPos-1].sub(numStack[numPos]);
							break;
						case 0x12: // *
							numStack[numPos-1].mul(numStack[numPos]);
							break;
						case 0x13: // /
							numStack[numPos-1].div(numStack[numPos]);
							break;
						case 0x14: // ^
							numStack[numPos-1].set(MyMath.pow(numStack[numPos-1],numStack[numPos]));
							break;
						case 'e':
							numStack[numPos-1].set(MyMath.exp(numStack[numPos-1]));
							break;
						case 'l':
							numStack[numPos-1].set(MyMath.log(numStack[numPos-1]));
							break;
						case '2':
							numStack[numPos-1].mul(numStack[numPos-1]);
							break;
						case 'q':
							numStack[numPos-1].set(MyMath.sqrt(numStack[numPos-1]));
							break;
						case 0x81: // sin
							numStack[numPos-1].set(MyMath.sin(numStack[numPos-1]));
							break;
						case 0x82: // cos
							numStack[numPos-1].set(MyMath.cos(numStack[numPos-1]));
							break;
						case 0x83: // tan
							numStack[numPos-1].set(MyMath.tan(numStack[numPos-1]));
							break;
						case 0x84: // asin
							numStack[numPos-1].set(MyMath.asin(numStack[numPos-1]));
							break;
						case 0x85: // asin
							numStack[numPos-1].set(MyMath.acos(numStack[numPos-1]));
							break;
						case 0x86: // atan
							numStack[numPos-1].set(MyMath.atan(numStack[numPos-1]));
						case 0x8a: // nCr
						case 0x80: // nPr
							numPos--;
							if (numPos<1) return 2;
							MyReal a = new MyReal();
							long n = numStack[numPos-1].getInt();
							long r = numStack[numPos].getInt();
							if (n<0 || r<0) return 1;
							long v = 1;
							for (;r>0;r--)
								v*=n--;
							numStack[numPos-1].set(v);
							if (expStack[expPos]!=0x80)
								numStack[numPos-1].div(MyMath.fact(numStack[numPos]));
							break;
						case 0x8b: // fact
							numStack[numPos-1].set(MyMath.fact(numStack[numPos-1]));
							break;
						case 0x8f: // -A
							numStack[numPos-1].inv();
							break;
						case '(':
							if (d==')') pri=0xf;
					}
					expPos--;
				}
				if (d!=')') {
					expStack[++expPos] = d;
				}
			}
			if (data[i]<0) break;
		}
		if (numPos!=1) return 2;
		ans.set(numStack[numPos-1]);
		return 0;
	}

	static int getPriority(int e){
		switch(e) {
			case '(':
			case ')':
				return 0;
			case 0x10:
			case 0x11:
				return 2;
			case 0x12:
			case 0x13:
				return 3;
			case '2':
				return 4;
		}
		return 6;
	}


	public static void drawExpr(Graphics g)
	{
		String funcTable[][]={
			{ "M",
			  "A", "B",  "C",
			  "D", "E",  "F",
			  "","", "",
			  "Ans","",      "" },
			{ "P",
			  "sin", "cos", "tan",
			  "asin","acos","atan",
			  "sinh","cosh","tanh",
			  "C",        "!" },
			{"+","-","x","/","^"},
		};
		int i;
		int p=0;
		for (i=0;data[i]>=0;i++) {
			if (i==cur && editFlag) {
				g.setColor(Graphics.getColorOfName(Graphics.GREEN));
				g.drawLine(p+10,20,p+18,20);
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			}
			if (data[i]<=9) {
				g.drawString(""+data[i], p+10,20);
				p+=6;
			}else if (data[i]==0xa) {
				g.drawString(".", p+10,20);
				p+=6;
			}else if (data[i]>=0x10 && data[i]<0x80){

				String s="?";
				if (data[i]>=0x10 && data[i]<0x15) {
					s=funcTable[2][data[i]&0xf];
				} else if (data[i]=='(') {
					s="(";
				} else if (data[i]==')') {
					s=")";
				} else if (data[i]=='2') {
					s="2";
				} else if (data[i]=='q') {
					s="";
				} else if (data[i]=='r') {
					s="y";
				} else if (data[i]=='e') {
					s="exp";
				//} else if (data[i]=='E') {
				///	s="EXP";
				} else if (data[i]=='l') {
					s="log";
				}

				if (s=="2") {
					g.drawString(s, p+10,16);
				} else {
					g.drawString(s, p+12,20);
				}
				p+=6*s.length()+4;
			} else if ((data[i]&0xf0)==0x80) {
				String s=funcTable[1][data[i]&0xf];
				g.drawString(s, p+12,20);
				p+=6*s.length()+4;
			} else if ((data[i]&0xf0)==0x90) {
				String s=funcTable[0][data[i]&0xf];
				g.drawString(s, p+12,20);
				p+=6*s.length()+4;
			}

		}
	}
}

final class MyCanvas extends Canvas {
	Image img;
	MyReal ans = new MyReal();
	int mode=0;
	int ret=0;
	int convTable[][]={
		{ Display.KEY_LEFT  , 0x10 , '(' , 'e'  },
		{ Display.KEY_RIGHT , 0x11 , ')' , 'l'  },
		{ Display.KEY_UP    , 0x12 , '2' , 0x14 },
		{ Display.KEY_DOWN  , 0x13 , 'q' , 'r' },
	};
	int convState=0;

	public MyCanvas()
	{
		Calc.clear();
		for (int i=0;i<Calc.var.length;i++)
			Calc.var[i] = new MyReal();
		try{
			MediaImage mediaImg = MediaManager.getImage("resource:///bg.gif");
			mediaImg.use(); img = mediaImg.getImage();
		}catch( ConnectionException e) {} catch( UIException e) {}
		setSoftLabel(SOFT_KEY_1,"Fn2");
		setSoftLabel(SOFT_KEY_2,"Fn");
	}

	public void paint(Graphics g)
	{
		g.lock();
		g.drawImage(img,0,0);

		if (mode!=3) {
			if (ret==0)
				g.drawString(ans.str(), 20,40);
			else
				g.drawString("ERR.", 20,40);
		} else {
			g.drawString("STO -> A-F", 20,40);
		}
		Calc.drawExpr(g);

		if (mode==1) {
			g.setColor(Graphics.getColorOfRGB(0xff,0x00,0x00));
			g.fillRect(getWidth()-16,8,4,4);
		}
		if (mode==2) {
			g.setColor(Graphics.getColorOfRGB(0xff,0x77,0x55));
			g.fillRect(getWidth()-16,8,4,4);
		}
		g.unlock(true);
	}
	public void processEvent(int type,int param)
	{
		if(type == Display.KEY_PRESSED_EVENT){

			// input conv
			if ((mode&0x10)!=0) {
				if(param == convTable[mode&0xf][0]) {
					convState = (convState+1)%(convTable[mode&0xf].length-1);
					Calc.data[Calc.cur]=convTable[mode&0xf][convState+1];
				} else {
					Calc.cur++;
					mode = 0;
				}
				if (param == Display.KEY_SELECT) {
					repaint();
					return;
				}
			}

			// change mode
			if(param == Display.KEY_SOFT1) {
				mode = mode==1?0:1;
				repaint();
				return;
			}
			if(param == Display.KEY_SOFT2) {
				mode = mode==2?0:2;
				repaint();
				return;
			}
			if (param == Display.KEY_CLEAR) {
				Calc.del();
			}
			// ??? > DEL
			if(param == 24) {
				Calc.del();
			}

			if (mode == 0){

				if (param == Display.KEY_SELECT) {
					ret=Calc.calc(ans);
				}

				// 0-9 .
				if (param >= Display.KEY_0 && param <= Display.KEY_ASTERISK ) {
					Calc.add(param);
				}

				// UP DOWN LEFT RIGHT
				for (int i=0;i<4;i++) {
					if(param == convTable[i][0]) {
						Calc.add(convTable[i][1]);
						Calc.cur--;
						mode = 0x10+i;
						convState=0x0;
						break;
					}
				}

				// AC
				if(param == Display.KEY_POUND) {
					ret=0;
					ans.set(0);
					Calc.clear();
				}

			} else if (mode == 1) {
				if (param == Display.KEY_SELECT) {
					mode = 3;
				}
				// <<
				if(param == Display.KEY_LEFT) {
					Calc.editFlag = true;
					if (Calc.cur>0) Calc.cur--;
				}
				if(param == Display.KEY_RIGHT) {
					Calc.editFlag = true;
					if (Calc.data[Calc.cur]>=0) Calc.cur++;
				}
				// Del
				if(param == Display.KEY_DOWN) {
					Calc.del();
				}

				if(param == Display.KEY_POUND) {
					IApplication.getCurrentApp().terminate();
				}
				if (param>=0 && param<=11) {
					Calc.add(param|0x90);
					mode = 0;
				}
			} else if (mode == 2) {
				// M+
				if(param == Display.KEY_UP) {
					Calc.calc(ans);
					Calc.var[0].add(ans);
				}
				// M-
				if(param == Display.KEY_DOWN) {
					Calc.calc(ans);
					Calc.var[0].sub(ans);
				}

				if(param == Display.KEY_RIGHT) {
					Calc.var[0].set(0);
				}
				if (param>=0 && param<=11) {
					Calc.add(param|0x80);
				}
				mode = 0;
			} else if (mode == 3) {
				Calc.calc(ans);
				if (param>=1 && param<=6)
					Calc.var[param].set(ans);
				mode = 0;
			} else {
				if(param == Display.KEY_SELECT) {
					mode=0;
				}
			}

		}
		repaint();
	}
}
